Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/c/iczoom.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/c/iczoom.cpp	(revision 2338)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/interface/c/iczoom.cpp	(revision 2339)
@@ -15,6 +15,6 @@
 #include "icutil.hpp"
 #include "timer.hpp"
-#include "zoom_axis.hpp"
-#include "zoom_domain.hpp"
+#include "extract_axis.hpp"
+#include "extract_domain.hpp"
 
 extern "C"
@@ -24,14 +24,16 @@
    // ----------------------- RedÃ©finition de types ----------------------------
 
-   typedef xios::CZoomAxis   * XZoomAxisPtr;
-   typedef xios::CZoomDomain * XZoomDomainPtr;
+   typedef xios::CExtractAxis   * XExtractAxisPtr;
+   typedef xios::CExtractDomain * XExtractDomainPtr;
    // ------------------------ CrÃ©ation des handle -----------------------------
-   void cxios_zoom_axis_handle_create (XZoomAxisPtr * _ret, const char * _id, int _id_len)
+   void cxios_zoom_axis_handle_create (XExtractAxisPtr * _ret, const char * _id, int _id_len)
    TRY
    {
       std::string id;
       if (!cstr2string(_id, _id_len, id)) return;
+      cout << "WARNING : you are using the zoom_axis interface. zoom_domain is deprecated, replace it with extract_axis." << endl;
+      cout << "\t Calls to xios_set/get_zoom_axis_attr must be replaced with xios_set/get_extract_axis_attr in your model." << endl;
       CTimer::get("XIOS").resume() ;
-      *_ret = xios::CZoomAxis::get(id);
+      *_ret = xios::CExtractAxis::get(id);
       CTimer::get("XIOS").suspend() ;
    }
@@ -44,7 +46,9 @@
       std::string id;
       if (!cstr2string(_id, _id_len, id)) return;
+      cout << "WARNING : you are using the zoom_axis interface. zoom_domain is deprecated, replace it with extract_axis." << endl;
+      cout << "\t Calls to xios_set/get_zoom_axis_attr must be replaced with xios_set/get_extract_axis_attr in your model." << endl;
 
       CTimer::get("XIOS").resume() ;
-      *_ret = xios::CZoomAxis::has(id);
+      *_ret = xios::CExtractAxis::has(id);
       CTimer::get("XIOS").suspend() ;
    }
@@ -52,11 +56,13 @@
 
    // ------------------------ CrÃ©ation des handle -----------------------------
-   void cxios_zoom_domain_handle_create(XZoomDomainPtr * _ret, const char * _id, int _id_len)
+   void cxios_zoom_domain_handle_create(XExtractDomainPtr * _ret, const char * _id, int _id_len)
    TRY
    {
       std::string id;
       if (!cstr2string(_id, _id_len, id)) return;
+      cout << "WARNING : you are using the zoom_domain interface. zoom_domain is deprecated, replace it with extract_domain." << endl;
+      cout << "\t Calls to xios_set/get_zoom_domain_attr must be replaced with xios_set/get_extract_domain_attr in your model." << endl;
       CTimer::get("XIOS").resume() ;
-      *_ret = xios::CZoomDomain::get(id);
+      *_ret = xios::CExtractDomain::get(id);
       CTimer::get("XIOS").suspend() ;
    }
@@ -69,7 +75,8 @@
       std::string id;
       if (!cstr2string(_id, _id_len, id)) return;
-
+      cout << "WARNING : you are using the zoom_domain interface. zoom_domain is deprecated, replace it with extract_domain." << endl;
+      cout << "\t Calls to xios_set/get_zoom_domain_attr must be replaced with xios_set/get_extract_domain_attr in your model." << endl;
       CTimer::get("XIOS").resume() ;
-      *_ret = xios::CZoomDomain::has(id);
+      *_ret = xios::CExtractDomain::has(id);
       CTimer::get("XIOS").suspend() ;
    }
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 2338)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/axis.cpp	(revision 2339)
@@ -47,5 +47,5 @@
    TRY
    {
-     m["zoom_axis"] = TRANS_ZOOM_AXIS;
+     m["zoom_axis"] = TRANS_EXTRACT_AXIS;
      m["interpolate_axis"] = TRANS_INTERPOLATE_AXIS;
      m["extract_axis"] = TRANS_EXTRACT_AXIS;
@@ -808,4 +808,8 @@
         if (ite != it)
         {
+          if (it->first == "zoom_axis")
+          {
+            info(0) << "WARNING : " << it->first << " is deprecated, replaced by extract_axis." << endl;
+          }
           transformationMap_.push_back(std::make_pair(it->second, CTransformation<CAxis>::createTransformation(it->second,
                                                                                                                nodeId,
Index: XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp
===================================================================
--- XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 2338)
+++ XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 2339)
@@ -2342,5 +2342,5 @@
   TRY
   {
-    m["zoom_domain"] = TRANS_ZOOM_DOMAIN;
+    m["zoom_domain"] = TRANS_EXTRACT_DOMAIN;
     m["interpolate_domain"] = TRANS_INTERPOLATE_DOMAIN;
     m["generate_rectilinear_domain"] = TRANS_GENERATE_RECTILINEAR_DOMAIN;
@@ -2536,4 +2536,8 @@
         if (ite != it)
         {
+          if (it->first == "zoom_domain")
+          {
+            info(0) << "WARNING : " << it->first << " is deprecated, replaced by extract_domain." << endl;
+          }
           transformationMap_.push_back(std::make_pair(it->second, CTransformation<CDomain>::createTransformation(it->second,
                                                                                                                 nodeId,